﻿using System.ComponentModel.DataAnnotations;

namespace BL.DTOs.Categories
{
    public class CategoryDTO
    {
        public int ID { get; set; }

        [Required]
        [MaxLength(256)]
        [Display(Name = "Category")]
        public string Name { get; set; }

        public bool HasParent => this.ParentID != null;

        /// <summary>
        /// Determines if products within this category 
        /// should be included in the search results
        /// </summary>
        public bool IsActive { get; set; }

        /// <summary>
        /// Parent category Id
        /// </summary>
        public int? ParentID { get; set; }

        public override string ToString()
        {
            return this.Name;
        }
    }
}
