﻿using System.ComponentModel.DataAnnotations;
using BL.Utils;
using BL.Utils.DataRepresentation;
using BL.Utils.Enums;
using BL.Utils.Validation;

namespace BL.DTOs.Filters
{
    public class ProductFilter
    {
        public int[] CategoryIds { get; set; }

        public string ProductName { get; set; }
        
        [RangeValidator]
        public Range<decimal> PriceRange { get; set; }

        /// <summary>
        /// Minimal rating used to filter
        /// out products with poor rating
        /// </summary>
        [Range(0.0, 10.0)]
        public double MinimalRating { get; set; }

        public ProductSortCriteria SortCriteria { get; set; }

        public bool SortAscending { get; set; }

        public ProductFilter()
        {
            PriceRange = new Range<decimal>();
        }
    }
}
