﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using DAL.Validation;

namespace BL.DTOs.Orders
{
    /// <summary>
    /// Wrapper class for order creation
    /// </summary>
    public class OrderCreateDTO
    {
        [Required]
        public OrderDTO Order { get; set; }

        public int CouponId { get; set; }

        [NonEmptyCollection]
        public IEnumerable<OrderItemDTO> OrderItems { get; set; } = new List<OrderItemDTO>();

        public int CustomerId { get; set; }
    }
}
