﻿using System;
using System.ComponentModel.DataAnnotations;

namespace BL.DTOs.Orders
{
    public class OrderDTO
    {
        public int ID { get; set; }
     
        [DataType(DataType.DateTime)]
        public DateTime Issued { get; set; }

        public decimal TotalPrice { get; set; }

        public int CustomerID { get; set; }

        public override string ToString()
        {
            return $"Order by {CustomerID}, issued at: {Issued}";
        }

        protected bool Equals(OrderDTO other)
        {
            if (ID > 0)
            {
                return this.ID == other.ID;
            }
            return Issued.Equals(other.Issued) &&
                TotalPrice == other.TotalPrice &&
                CustomerID == other.CustomerID;
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj))
            {
                return false;
            }
            if (ReferenceEquals(this, obj))
            {
                return true;
            }
            return obj.GetType() == this.GetType() &&
                Equals((OrderDTO)obj);
        }

        public override int GetHashCode()
        {
            unchecked
            {
                var hashCode = ID;
                hashCode = (hashCode * 397) ^ Issued.GetHashCode();
                hashCode = (hashCode * 397) ^ TotalPrice.GetHashCode();
                hashCode = (hashCode * 397) ^ CustomerID;
                return hashCode;
            }
        }
    }
}
