﻿using System.ComponentModel.DataAnnotations;

namespace BL.DTOs.Stocks
{
    /// <summary>
    /// Product available at eshop goods storage
    /// </summary>
    public class StockDTO
    {
        public int ID { get; set; }

        [Required]
        public int ProductID { get; set; }

        /// <summary>
        /// Number of units avaiable at the storage
        /// </summary>
        [Range(0, int.MaxValue)]
        public int StoredUnits { get; set; }

        public override string ToString()
        {
            return $"Stock with product ID: {ProductID} available in {StoredUnits}x";
        }
    }
}
