﻿using System.Linq;
using AutoMapper.QueryableExtensions;
using BL.AppInfrastructure;
using BL.DTOs.Filters;
using BL.DTOs.Orders;
using DAL.Entities;
using Riganti.Utils.Infrastructure.Core;

namespace BL.Queries
{
    public class OrderItemListQuery : AppQuery<OrderItemDTO>
    {
        public OrderItemFilter Filter { get; set; }

        public OrderItemListQuery(IUnitOfWorkProvider provider) : base(provider) { }

        protected override IQueryable<OrderItemDTO> GetQueryable()
        {
            IQueryable<OrderItem> query = Context.OrderItems;

            if (Filter.OrderId > 0)
            {
                query = query.Where(orderItem => orderItem.Order.ID == Filter.OrderId);
            }

            return query.ProjectTo<OrderItemDTO>();
        }
    }
}
