﻿using System.Linq;
using AutoMapper.QueryableExtensions;
using BL.AppInfrastructure;
using BL.DTOs.Filters;
using BL.DTOs.Reviews;
using DAL.Entities;
using Riganti.Utils.Infrastructure.Core;

namespace BL.Queries
{
    public class ProductReviewListQuery : AppQuery<ProductReviewDTO>
    {
        public ProductReviewFilter Filter { get; set; }

        public ProductReviewListQuery(IUnitOfWorkProvider provider) : base(provider) { }

        protected override IQueryable<ProductReviewDTO> GetQueryable()
        {
            IQueryable<ProductReview> query = Context.ProductReviews;

            if (Filter.ProductId > 0)
            {
                query = query.Where(review => review.Product.ID == Filter.ProductId);
            }
            return query.ProjectTo<ProductReviewDTO>();
        }
    }
}
