﻿using System.Linq;
using BL.AppInfrastructure;
using BL.DTOs.Filters;
using DAL.Entities;
using Riganti.Utils.Infrastructure.Core;

namespace BL.Queries
{
    public class StocksListQuery : AppQuery<Stock>
    {
        public StockFilter Filter { get; set; }

        public StocksListQuery(IUnitOfWorkProvider provider) : base(provider) { }

        protected override IQueryable<Stock> GetQueryable()
        {
            IQueryable<Stock> query = Context.Stocks;
            if (Filter.ProductId > 0)
            {
                query = query.Where(stock => stock.Product.ID == Filter.ProductId);
            }
            return query;
        }
    }
}
