using BL.DTOs.Filters;
using BL.DTOs.Products;

namespace BL.Services.Products
{
    /// <summary>
    /// Handles Product CRUD and querying (with paging support)
    /// </summary>
    public interface IProductService
    {
        int ProductsPageSize { get; }

        void CreateProduct(ProductDTO productDto, int categoryId);

        void EditProduct(ProductDTO productDto, int categoryId, params int[] productReviewIds);

        void DeleteProduct(int productId);
        ProductDTO GetProduct(int productId);

        /// <summary>
        /// Gets products according to filter and required page
        /// </summary>
        /// <param name="filter">products filter</param>
        /// <param name="requiredPage">page to show</param>
        /// <returns></returns>
        ProductListQueryResultDTO ListProducts(ProductFilter filter, int requiredPage = 1);
    }
}