namespace BL.Services.Promote
{
    /// <summary>
    /// Handles e-shop promo offers (discount coupons)
    /// </summary>
    public interface IPromoteService
    {      
        /// <summary>
        /// Creates discount coupon for specified customer
        /// </summary>
        /// <param name="customerId">Id of customer who will be given the coupon</param>
        /// <param name="promoCode">Optional promo code</param>
        /// <param name="asBirthdayCoupon"></param>
        string CreateCoupon(int customerId, string promoCode = null, bool asBirthdayCoupon = false);

        /// <summary>
        /// Sends birthday coupon (in fact just the promo code) to 
        /// corresponding customer if and only if all conditions are satisfied
        /// </summary>
        /// <param name="customerId">ID of coupon receiver</param>
        /// <returns>true if coupon was sent</returns>
        bool SendBirthDayCouponIfPossible(int customerId);

        /// <summary>
        /// Sends loyalty coupon(in fact just the promo code) to
        /// corresponding customer if and only if all conditions are satisfied
        /// </summary>
        /// <param name="customerId">ID of coupon receiver</param>
        /// <returns>true if coupon was sent</returns>
        bool SendLoyaltyCouponIfPossible(int customerId);
    }
}