using System.Collections.Generic;
using BL.DTOs.Reviews;

namespace BL.Services.Rating
{
    public interface IRatingService
    {
        /// <summary>
        /// Adds review
        /// </summary>
        /// <param name="reviewDto">Review details</param>
        void AddReview(ProductReviewCreateDTO reviewDto);

        /// <summary>
        /// Updates review
        /// </summary>
        /// <param name="reviewDto">Update details</param>
        void EditReview(ProductReviewEditDTO reviewDto);

        /// <summary>
        /// Deletes review
        /// </summary>
        /// <param name="id">ID of review to delete</param>
        void DeleteReview(int reviewId);
        
        /// <summary>
        /// Gets all reviews of given product
        /// </summary>
        /// <param name="productId">product id</param>
        /// <returns>all reviews of given product</returns>
        IEnumerable<ProductReviewDTO> GetAllReviewsForProduct(int productId);
    }
}