﻿using System;
using BL.DTOs.Orders;
using DAL.Enums;

namespace BL.Utils.PriceCalculators
{
    public class PercentagePriceCalculator : IPriceCalculator
    {
        public DiscountType DiscountType { get; } = DiscountType.Percentage;

        public decimal CalculatePrice(OrderItemDTO orderItem)
        {
            if (orderItem.Product.DiscountPercentage.HasValue)
            {
                var pricePerSingleProduct = Math.Round(orderItem.Product.Price * (decimal)(1 - orderItem.Product.DiscountPercentage.Value/100.0));
                return pricePerSingleProduct * orderItem.Quantity;
            }
            return orderItem.Product.Price * orderItem.Quantity;
        }
    }
}
