﻿using BL.DTOs.Orders;
using DAL.Enums;

namespace BL.Utils.PriceCalculators
{
    public class Quantity3Plus1PriceCalculator : IPriceCalculator
    {
        private const int RequiredForDiscount = 4;

        public DiscountType DiscountType { get; } = DiscountType.Quantity3Plus1;

        public decimal CalculatePrice(OrderItemDTO orderItem)
        {
            var numberOfFreeProducts = orderItem.Quantity / RequiredForDiscount;
            return (orderItem.Quantity - numberOfFreeProducts) * orderItem.Product.Price;
        }
    }
}
