﻿using System.Collections.Generic;
using System.Linq;
using BL.Utils.PriceCalculators;
using DAL.Enums;

namespace BL.Utils.Resolvers
{
    /// <summary>
    /// Handles price calculator resolving
    /// </summary>
    public class PriceCalculatorResolver : IPriceCalculatorResolver
    {
        /// <summary>
        /// Registered price calculators
        /// </summary>
        private readonly IEnumerable<IPriceCalculator> priceCalculators;

        public PriceCalculatorResolver(IEnumerable<IPriceCalculator> priceCalculators)
        {
            this.priceCalculators = priceCalculators;
        }

        public IPriceCalculator Resolve(DiscountType discountType)
        {
            return priceCalculators.First(calculator => calculator.DiscountType.Equals(discountType));
        }
    }
}
