﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using Riganti.Utils.Infrastructure.Core;

namespace DAL.Entities
{
    /// <summary>
    /// Product Category (hierarchical structure)
    /// </summary>
    public class Category : IEntity<int>
    {
        public int ID { get; set; }

        [Required]
        [MaxLength(256)]
        public string Name { get; set; }

        [NotMapped]
        public bool HasParent => this.Parent != null;

        /// <summary>
        /// Parent category
        /// </summary>
        public virtual Category Parent { get; set; }

        /// <summary>
        /// Products within the category
        /// </summary>
        public virtual List<Product> Products { get; set; }
    }
}
