﻿using System;
using System.ComponentModel.DataAnnotations;
using Riganti.Utils.Infrastructure.Core;

namespace DAL.Entities
{
    /// <summary>
    /// Coupon with promo code discount for the overall order
    /// </summary>
    public class Coupon : IEntity<int>
    {
        public int ID { get; set; }

        [Range(0, 100)]
        public int DiscountPercentage { get; set; }

        [MaxLength(8)]
        [Required]
        public string PromoCode { get; set; }

        [Required]
        public DateTime Issued { get; set; }

        [Required]
        public virtual Customer Customer { get; set; }

        public virtual Order Order { get; set; }
    }
}
