﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using DAL.Validation;
using Riganti.Utils.Infrastructure.Core;

namespace DAL.Entities
{
    /// <summary>
    /// Customer order
    /// </summary>
    public class Order : IEntity<int>
    {        
        public int ID { get; set; }

        public DateTime Issued { get; set; }

        public decimal TotalPrice { get; set; }

        [Required]
        public virtual Customer Customer { get; set; }

        public virtual Coupon Coupon { get; set; }

        [NonEmptyCollection]
        public virtual List<OrderItem> OrderItems { get; set; }
    }
}
