﻿using System.ComponentModel.DataAnnotations;
using Riganti.Utils.Infrastructure.Core;

namespace DAL.Entities
{
    /// <summary>
    /// Single item within customer order
    /// </summary>
    public class OrderItem : IEntity<int>
    {
        public int ID { get; set; }

        [Range(0, int.MaxValue)]
        public int Quantity { get; set; }

        [Required]
        public virtual Product Product { get; set; }

        [Required]
        public virtual Order Order { get; set; }
    }
}
