﻿using System.ComponentModel.DataAnnotations;
using Riganti.Utils.Infrastructure.Core;

namespace DAL.Entities
{
    /// <summary>
    /// Product available at eshop goods storage
    /// </summary>
    public class Stock : IEntity<int>
    {
        public int ID { get; set; }

        /// <summary>
        /// Number of units avaiable at the storage
        /// </summary>
        [Range(0, int.MaxValue)]
        public int StoredUnits { get; set; }

        [Required]
        public virtual Product Product { get; set; }
    }
}
