﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using BL.DTOs;
using BL.DTOs.Coupons;
using BL.DTOs.Customers;
using BL.DTOs.Orders;

namespace PL.Models
{
    public class ShoppingCartViewModel
    {
        public IList<OrderItemDTO> ShoppingCartItems { get; set; }

        public CustomerDTO Customer { get; set; }

        public CouponDTO Coupon { get; set; }

        [Range(0, int.MaxValue)]
        [DataType(DataType.Currency)]
        public decimal TotalPrice { get; set; }

        public ShoppingCartViewModel()
        {
            ShoppingCartItems = new List<OrderItemDTO>();
        }
    }
}