﻿using System.Web.Mvc;
using BrockAllen.MembershipReboot;
using BrockAllen.MembershipReboot.WebHost;
using Castle.MicroKernel.Registration;
using Castle.MicroKernel.SubSystems.Configuration;
using Castle.Windsor;
using UserAccount = Riganti.Utils.Infrastructure.EntityFramework.UserAccount;

namespace PL
{
    public class MvcInstaller : IWindsorInstaller
    {
        public void Install(IWindsorContainer container, IConfigurationStore store)
        {
            container.Register(
                Component.For<SamAuthenticationService<UserAccount>>()
                    .ImplementedBy<SamAuthenticationService<UserAccount>>()
                    .DependsOn(Dependency.OnComponent<UserAccountService<UserAccount>, UserAccountService<UserAccount>>())
                    .LifestyleTransient(),

           

                Classes.FromThisAssembly()
                    .BasedOn<IController>()
                    .LifestyleTransient()
                    );
        }
    }
}
